#include <GLCD.h>
#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include <stdlib.h>

uint8_t Direction;
void GLCD_Delay(void)
{

		;
//  asm("nop");asm("nop");asm("nop");asm("nop");
        __nop();__nop();__nop();__nop();__nop();__nop();
}		


void GLCD_CS(uint8_t cheap)
{
	if (cheap)
	{
	SET_CS1;
	RESET_CS2;	
	}
	else
	{
	SET_CS2;
	RESET_CS1;
	}
}

void GLCD_Init(void) 
{
	GLCD_Set_IO_RCC();
	GLCD_Set_Control_IO_OUT();
	GLCD_Set_Data_IO_OUT();
	//SET_EN;
	RESET_RST;
	GLCD_Delay();
	SET_RST;
	GLCD_Delay();
	GLCD_Write_Command(GLCD_ON,GLCD_LEFT);
	GLCD_Write_Command(GLCD_ON,GLCD_RIGHT);
	GLCD_Delay();
	RESET_CS1;
	RESET_CS2;
	
}

void GLCD_Write_Data(uint16_t data,uint8_t cheap)
{
	GLCD_CS_EN(cheap);
	if (Direction!=1)
		GLCD_Set_Data_IO_OUT();
	SET_EN;
	GLCD_EN_DELAY();
	SET_DI;
	RESET_RW;
	GLCD_DATA_OUT(data&0xFF);
	RESET_EN;
	GLCD_EN_DELAY();
	GLCD_CS_DIS(cheap);

}





void GLCD_Write_Command(uint16_t cmd,uint8_t cheap)
{
	GLCD_CS_EN(cheap);
	if (Direction!=1)
		GLCD_Set_Data_IO_OUT();
	SET_EN;
	GLCD_EN_DELAY();
	RESET_DI;//1<<9
	RESET_RW;
	GLCD_DATA_OUT(cmd&0xFF);
	RESET_EN;
	GLCD_EN_DELAY();
	GLCD_CS_DIS(cheap);
	
}

uint16_t GLCD_Read_Data(uint8_t cheap)
{
	uint16_t data;
	GLCD_CS_EN(cheap);
	
	if (Direction!=0)
		GLCD_Set_Data_IO_IN();
	
	SET_EN;
	SET_DI;
	RESET_RW;
	data=GLCD_DATA_IN();
	RESET_EN;
	GLCD_CS_DIS(cheap);
	return data;
}





uint16_t GLCD_Read_Command(uint8_t cheap)
{
	uint16_t cmd;
	GLCD_CS_EN(cheap);
	
	if (Direction!=0)
		GLCD_Set_Data_IO_IN();
	SET_EN;
	RESET_DI;//1<<9
	RESET_RW;
	cmd=GLCD_DATA_IN();
	RESET_EN;
	GLCD_CS_DIS(cheap);
	return cmd;
}



void GLCD_SetYAdd(uint8_t adr,uint8_t cheap) 
{
GLCD_Write_Command(adr|0x40,cheap);
	
}
void GLCD_SetPage(uint8_t page,uint8_t cheap) 
{
GLCD_Write_Command(page|0xB8,cheap);
}
void GLCD_SetDisplayStartLine(uint8_t line,uint8_t cheap) 
{
GLCD_Write_Command(line|0xC0,cheap);
}



uint8_t GLCD_ReadDisplayData(uint8_t cheap) 
{
return GLCD_ReadDisplayData( cheap);
}

uint8_t GLCD_ReadStatusFlags(uint8_t cheap) 
{
return GLCD_Read_Command( cheap);
}
void GLCD_CS_EN(uint8_t cheap)
{
	if (cheap==GLCD_LEFT)
	{
	SET_CS1;
	//RESET_CS2;	
	}
	else
	{
	SET_CS2;
	//RESET_CS1;
	}
}
void GLCD_CS_DIS(uint8_t cheap)
{
	if (cheap==GLCD_LEFT)
	{
	RESET_CS1;
	//SET_CS2;	
	}
	else
	{
	RESET_CS2;
	//SET_CS1;		
	}
}
void GLCD_Set_XY_PAGE(uint8_t X,uint8_t Y)
{
	uint8_t dir;
	if (Y<64)
	{
		GLCD_SetYAdd(Y,GLCD_LEFT);
		dir=GLCD_LEFT;
	}
	else
	{
		Y-=64;
		GLCD_SetYAdd(Y,GLCD_RIGHT);
		dir=GLCD_RIGHT;
	}	
	X=(uint8_t) X/8;
	GLCD_SetPage(X,dir);
	
}
void GLCD_WRITE_XY(uint8_t X,uint8_t Y,uint8_t Bit)
{
	uint8_t tmp,tmp2;
	uint8_t dir;
	if (Y<64)
	{
		GLCD_SetYAdd(Y,GLCD_LEFT);
		dir=GLCD_LEFT;
	}
	else
	{
		Y-=64;
		GLCD_SetYAdd(Y,GLCD_RIGHT);
		dir=GLCD_RIGHT;
	}	
	tmp2=(uint8_t) X/8;
	
	GLCD_SetPage(tmp2,dir);
	tmp2=X-tmp2*8;
	if(Bit)
	{
		tmp=tmp|(1<<tmp2);
	}
	else
	{
		tmp=tmp&!(1<<tmp2);
	}
	GLCD_Write_Data(tmp,dir);
	//GLCD_WriteDisplayData(tmp);
	//GLCD_WriteDisplayData(0xff);
	//GLCD_Write_Data(0xFF);
	GLCD_Delay();
}





void GLCD_Set_IO_RCC(void)
{
RCC_APB2PeriphClockCmd(D_PORT0_RCC,ENABLE);
RCC_APB2PeriphClockCmd(D_PORT1_RCC,ENABLE);
RCC_APB2PeriphClockCmd(D_PORT2_RCC,ENABLE);
RCC_APB2PeriphClockCmd(D_PORT3_RCC,ENABLE);
RCC_APB2PeriphClockCmd(D_PORT4_RCC,ENABLE);
RCC_APB2PeriphClockCmd(D_PORT5_RCC,ENABLE);
RCC_APB2PeriphClockCmd(D_PORT6_RCC,ENABLE);
RCC_APB2PeriphClockCmd(D_PORT7_RCC,ENABLE);
RCC_APB2PeriphClockCmd(CS1_PORT_RCC,ENABLE);
RCC_APB2PeriphClockCmd(CS2_PORT_RCC,ENABLE);
//RCC_APB2PeriphClockCmd(CS3_PORT_RCC,ENABLE);
RCC_APB2PeriphClockCmd(DI_PORT_RCC,ENABLE);	
RCC_APB2PeriphClockCmd(EN_PORT_RCC,ENABLE);	
RCC_APB2PeriphClockCmd(RW_PORT_RCC,ENABLE);	
RCC_APB2PeriphClockCmd(RST_PORT_RCC,ENABLE);	
}
void GLCD_Set_Control_IO_OUT(void)
{
	
				GPIO_InitTypeDef GPIO_InitStructure;

        GPIO_InitStructure.GPIO_Pin = CS1_PIN;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
        GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
        GPIO_Init(CS1_PORT, &GPIO_InitStructure);
				
        GPIO_InitStructure.GPIO_Pin = CS2_PIN;
        GPIO_Init(CS2_PORT, &GPIO_InitStructure);
				
	//			GPIO_InitStructure.GPIO_Pin = CS3_PIN;
  //      GPIO_Init(CS3_PORT, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = DI_PIN;
				GPIO_Init(DI_PORT, &GPIO_InitStructure);
				
				GPIO_InitStructure.GPIO_Pin = RST_PIN;
        GPIO_Init(RST_PORT, &GPIO_InitStructure);
				
				GPIO_InitStructure.GPIO_Pin = EN_PIN;
        GPIO_Init(EN_PORT, &GPIO_InitStructure);
				
				GPIO_InitStructure.GPIO_Pin = RW_PIN;
        GPIO_Init(RW_PORT, &GPIO_InitStructure);
	
				
}
void GLCD_Set_Data_IO_OUT(void)
{
	
				GPIO_InitTypeDef GPIO_InitStructure;
Direction=1;
        GPIO_InitStructure.GPIO_Pin = D_PIN0;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
        GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
        GPIO_Init(D_PORT0, &GPIO_InitStructure);
				
        GPIO_InitStructure.GPIO_Pin = D_PIN1;
        GPIO_Init(D_PORT1, &GPIO_InitStructure);
				
				GPIO_InitStructure.GPIO_Pin = D_PIN2;
        GPIO_Init(D_PORT2, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN3;
        GPIO_Init(D_PORT3, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN4;
        GPIO_Init(D_PORT4, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN5;
        GPIO_Init(D_PORT5, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN6;
        GPIO_Init(D_PORT6, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN7;
        GPIO_Init(D_PORT7, &GPIO_InitStructure);

				
}	

void GLCD_Set_Data_IO_IN(void)
{
	
				GPIO_InitTypeDef GPIO_InitStructure;
Direction=0;
        GPIO_InitStructure.GPIO_Pin = D_PIN0;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
        GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
        GPIO_Init(D_PORT0, &GPIO_InitStructure);
				
        GPIO_InitStructure.GPIO_Pin = D_PIN1;
        GPIO_Init(D_PORT1, &GPIO_InitStructure);
				
				GPIO_InitStructure.GPIO_Pin = D_PIN2;
        GPIO_Init(D_PORT2, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN3;
        GPIO_Init(D_PORT3, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN4;
        GPIO_Init(D_PORT4, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN5;
        GPIO_Init(D_PORT5, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN6;
        GPIO_Init(D_PORT6, &GPIO_InitStructure);
	
				GPIO_InitStructure.GPIO_Pin = D_PIN7;
        GPIO_Init(D_PORT7, &GPIO_InitStructure);

				
}







void GLCD_EN_DELAY(void)
{
	uint16_t j=0;
	for(j=0;j<200;j++)
	__nop();
	
	
}

uint8_t GLCD_DATA_IN(void)
{
	return Read_DP_0<<0 & Read_DP_1 <<1 & Read_DP_2 <<2 & Read_DP_3 <<3 & Read_DP_4 <<4 & Read_DP_5 <<5 & Read_DP_6 <<6 & Read_DP_7 <<7;
}

void GLCD_DATA_OUT(uint8_t data)
{
	(((data&0x01)>0)?(SET_DP0):(RESET_DP0));(((data&0x02)>0) ?(SET_DP1):(RESET_DP1));((data&0x04)>0 ? (SET_DP2):(RESET_DP2));((data&0x08)>0 ? (SET_DP3):(RESET_DP3));((data&0x10)>0 ? (SET_DP4):(RESET_DP4));((data&0x20)>0 ? (SET_DP5): (RESET_DP5));((data&0x40)>0 ? (SET_DP6): (RESET_DP6));((data&0x80)>0 ? (SET_DP7):(RESET_DP7));
}
void GLCD_EN_LATCH(void)
{

	GLCD_Delay();

}









































const unsigned char color = 1;
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Rectangle(unsigned char x, unsigned char y, unsigned char b, unsigned char a)
{
  unsigned char j; // zmienna pomocnicza
  // rysowanie linii pionowych (boki)
  for (j = 0; j < a; j++) {
		GLCD_WRITE_XY(x, y + j, color);
		GLCD_WRITE_XY(x + b - 1, y + j, color);
	}
  // rysowanie linii poziomych (podstawy)
  for (j = 0; j < b; j++)	{
		GLCD_WRITE_XY(x + j, y, color);
		GLCD_WRITE_XY(x + j, y + a - 1, color);
	}
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius)
{
int x, y, xchange, ychange, radiusError;
x = radius;
y = 0;
xchange = 1 - 2 * radius;
ychange = 1;
radiusError = 0;
while(x >= y)
  {
  GLCD_WRITE_XY(cx+x, cy+y, color); 
  GLCD_WRITE_XY(cx-x, cy+y, color); 
  GLCD_WRITE_XY(cx-x, cy-y, color);
  GLCD_WRITE_XY(cx+x, cy-y, color); 
  GLCD_WRITE_XY(cx+y, cy+x, color); 
  GLCD_WRITE_XY(cx-y, cy+x, color); 
  GLCD_WRITE_XY(cx-y, cy-x, color); 
  GLCD_WRITE_XY(cx+y, cy-x, color); 
  y++;
  radiusError += ychange;
  ychange += 2;
  if ( 2*radiusError + xchange > 0 )
    {
    x--;
	radiusError += xchange;
	xchange += 2;
	}
  }
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Line(int X1, int Y1,int X2,int Y2)
{
int CurrentX, CurrentY, Xinc, Yinc, 
    Dx, Dy, TwoDx, TwoDy, 
	TwoDxAccumulatedError, TwoDyAccumulatedError;

Dx = (X2-X1); // obliczenie skadowej poziomej
Dy = (Y2-Y1); // obliczenie skadowej pionowej

TwoDx = Dx + Dx; // podwojona skadowa pozioma
TwoDy = Dy + Dy; // podwojona skadowa pionowa

CurrentX = X1; // zaczynamy od X1
CurrentY = Y1; // oraz Y1

Xinc = 1; // ustalamy krok zwikszania pozycji w poziomie 
Yinc = 1; // ustalamy krok zwikszania pozycji w pionie

if(Dx < 0) // jesli skadowa pozioma jest ujemna 
  {
  Xinc = -1; // to bdziemy si "cofa" (krok ujemny)
  Dx = -Dx;  // zmieniamy znak skadowej na dodatni
  TwoDx = -TwoDx; // jak rwnie podwojonej skadowej
  }

if (Dy < 0) // jeli skadowa pionowa jest ujemna
  {
  Yinc = -1; // to bdziemy si "cofa" (krok ujemny)
  Dy = -Dy; // zmieniamy znak skadowej na dodatki
  TwoDy = -TwoDy; // jak rwniez podwojonej skadowej
  }

GLCD_WRITE_XY(X1,Y1, color); // stawiamy pierwszy krok (zapalamy pierwszy piksel)

if ((Dx != 0) || (Dy != 0)) // sprawdzamy czy linia skada si z wicej ni jednego punktu ;)
  {
  // sprawdzamy czy skadowa pionowa jest mniejsza lub rwna skadowej poziomej
  if (Dy <= Dx) // jeli tak, to idziemy "po iksach"
    { 
    TwoDxAccumulatedError = 0; // zerujemy zmienn 
    do // ruszamy w drog
	  {
      CurrentX += Xinc; // do aktualnej pozycji dodajemy krok 
      TwoDxAccumulatedError += TwoDy; // a tu dodajemy podwojon skadow pionow
      if(TwoDxAccumulatedError > Dx)  // jeli TwoDxAccumulatedError jest wikszy od Dx
        {
        CurrentY += Yinc; // zwikszamy aktualn pozycj w pionie
        TwoDxAccumulatedError -= TwoDx; // i odejmujemy TwoDx
        }
       GLCD_WRITE_XY(CurrentX,CurrentY, color);// stawiamy nastpny krok (zapalamy piksel)
       }while (CurrentX != X2); // idziemy tak dugo, a osigniemy punkt docelowy
     }
   else // w przeciwnym razie idziemy "po igrekach" 
      {
      TwoDyAccumulatedError = 0; 
      do 
	    {
        CurrentY += Yinc; 
        TwoDyAccumulatedError += TwoDx;
        if(TwoDyAccumulatedError>Dy) 
          {
          CurrentX += Xinc;
          TwoDyAccumulatedError -= TwoDy;
          }
         GLCD_WRITE_XY(CurrentX,CurrentY, color); 
         }while (CurrentY != Y2);
    }
  }
}

void GLCD_ClearScreen(void)
{
uint8_t j,k,l;
for(l=GLCD_LEFT;l<3;l++)
for(j=0;j<64;j++)
{	
		GLCD_SetYAdd(j,l);
		for(k=0;k<8;k++)
		{
		GLCD_SetPage(k,l);
	
		GLCD_Write_Data(0xFF,l);
	
		}

	}
}


void glcd_dline(int x1, int y1, int x2, int y2, uint8_t color)
{
   signed int  x, y, addx, addy, dx, dy;
   signed long P;
   int i;
   dx = abs((signed int)(x2 - x1));
   dy = abs((signed int)(y2 - y1));
   x = x1;
   y = y1;

   if(x1 > x2)
      addx = -1;
   else
      addx = 1;
   if(y1 > y2)
      addy = -1;
   else
      addy = 1;

   if(dx >= dy)
   {
      P = 2*dy - dx;

      for(i=0; i<=dx; ++i)
      {
         GLCD_WRITE_XY(x, y, color);

         if(P < 0)
         {
            P += 2*dy;
            x += addx;
         }
         else
         {
            P += 2*dy - 2*dx;
            x += addx;
            y += addy;
         }
      }
   }
   else
   {
      P = 2*dx - dy;

      for(i=0; i<=dy; ++i)
      {
         GLCD_WRITE_XY(x, y, color);

         if(P < 0)
         {
            P += 2*dx;
            y += addy;
         }
         else
         {
            P += 2*dx - 2*dy;
            x += addx;
            y += addy;
         }
      }
   }
}
